﻿//MrTabardSwitcher


using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Net.Mail;
using System.Runtime.InteropServices;
using Styx.Common;
using System;
using Styx.Plugins;
using Styx;
using Styx.CommonBot;
using Styx.Common.Helpers;
using Styx.CommonBot.POI;
using Styx.CommonBot.Profiles;
using Styx.CommonBot.Database;
using Styx.Common;
using Styx.CommonBot.Frames;
using Styx.WoWInternals.WoWObjects;
using System.IO;
using System.Xml.Linq;
using Styx;
using Styx.CommonBot.Inventory;
using Styx.WoWInternals;
using System.Threading;

namespace MrTabardSwitcher
{

    public class MrTabardSwitcher : HBPlugin
    {
        //Normal Stuff.
        public override string Name
        {
            get { return "MrTabardSwitcher"; }
        }

        public override string Author
        {
            get { return "CnG"; }
        }

        public override Version Version
        {
            get { return new Version(1, 7); }
        }

        public override bool WantButton
        {
            get { return true; }
        }

        public override string ButtonText
        {
            get { return "MrTabardSwitcher"; }
        }

        //Logging Class for your conviance
        private static void Slog(string format, params object[] args)
        {
            Logging.Write("[MrTabardSwitcher: " + format, args);
        }



        public override void Initialize()
        {

            if (Me.IsAlliance)
            {
                Slog("-------------------Current Rep-------------------");
                Slog("Stormwind: {0} TotalPoints: {1}", Me.GetReputationLevelWith(72).ToString(), Me.GetReputationWith(72).ToString());
                Slog("Tushui Pandaren: {0} TotalPoints: {1}", Me.GetReputationLevelWith(1353).ToString(), Me.GetReputationWith(1353).ToString());
                Slog("Ironforge: {0} TotalPoints: {1}", Me.GetReputationLevelWith(47).ToString(), Me.GetReputationWith(47).ToString());
                Slog("Gnomeregan: {0} TotalPoints: {1}", Me.GetReputationLevelWith(54).ToString(), Me.GetReputationWith(54).ToString());
                Slog("Darnassus: {0} TotalPoints: {1}", Me.GetReputationLevelWith(69).ToString(), Me.GetReputationWith(69).ToString());
                Slog("Gilneas: {0} TotalPoints: {1}", Me.GetReputationLevelWith(1134).ToString(), Me.GetReputationWith(1134).ToString());
                Slog("Exodar: {0} TotalPoints: {1}", Me.GetReputationLevelWith(930).ToString(), Me.GetReputationWith(930).ToString());
                Slog("--------------------------------------------------");
            }
            if (Me.IsHorde)
            {
                Slog("-------------------Current Rep-------------------");
                Slog("Thunder Bluff: {0} TotalPoints: {1}", Me.GetReputationLevelWith(81).ToString(), Me.GetReputationWith(81).ToString());
                Slog("Darkspear Trolls: {0} TotalPoints: {1}", Me.GetReputationLevelWith(530).ToString(), Me.GetReputationWith(530).ToString());
                Slog("Orgrimmar: {0} TotalPoints: {1}", Me.GetReputationLevelWith(76).ToString(), Me.GetReputationWith(76).ToString());
                Slog("Bilgewater Cartel Goblins: {0} TotalPoints: {1}", Me.GetReputationLevelWith(1133).ToString(), Me.GetReputationWith(1133).ToString());
                Slog("Huojin Pandas: {0} TotalPoints: {1}", Me.GetReputationLevelWith(1352).ToString(), Me.GetReputationWith(1352).ToString());
                Slog("Undercity: {0} TotalPoints: {1}", Me.GetReputationLevelWith(68).ToString(), Me.GetReputationWith(68).ToString());
                Slog("Silvermoon: {0} TotalPoints: {1}", Me.GetReputationLevelWith(911).ToString(), Me.GetReputationWith(911).ToString());
                Slog("--------------------------------------------------");
            }
       
        }

        private static LocalPlayer Me { get { return StyxWoW.Me; } }
      

        public override void Pulse()
        {
           
            if(Me.Combat && Me.IsAlive)
            {
                return;
            }
            if(Me.IsAlliance)
            {
                Alliance();
                return;
            }
            if (Me.IsHorde)
            {
                Horde();
                return;
            }


        }
        public void Alliance()
        {
            if (IsMaxExalted(72) && IsMaxExalted(1353) && IsMaxExalted(47) &&
                IsMaxExalted(54) && IsMaxExalted(69) && IsMaxExalted(1134) &&
                IsMaxExalted(930))
            {
                foreach (PluginContainer Plugin in Styx.Plugins.PluginManager.Plugins)
                {
                    if (Plugin.Name == "MrTabardSwitcher")
                    {
                        Slog("Congradulations! Your now Exalted with all Major Factions! Disabling MrTabardSwitcher");
                        Plugin.Enabled = false;
                    }
                }
            }
            //Checking incase tabards are null.
            if (StyxWoW.Me.Inventory.Equipped.Tabard.Entry == null)
            {
                Slog("No Currently Equiped Tabard!");
                //got an issue, theres not a tabard already equiped. finding one to equip.
                //Checking for SW Rep, then if we have the item to equip.
                if (!IsMaxExalted(72) && HasItem(45574))
                {

                    Slog("Need More Reputation with Stormwind, Equiping correct Tabard.");
                    Equipbyid(45574);
                    return;

                }
                if (!IsMaxExalted(1353) && HasItem(83079))
                {

                    Slog("Need More Reputation with Tushui Pandaren, Equiping correct Tabard.");
                    Equipbyid(83079);
                    return;

                }
                if (!IsMaxExalted(47) && HasItem(45577))
                {
                    Slog("Need More Reputation with Ironforge, Equiping correct Tabard.");
                    Equipbyid(45577);
                    return;

                }
                if (!IsMaxExalted(54) && HasItem(45578))
                {
                    Slog("Need More Reputation with Gnomeregan, Equiping correct Tabard.");
                    Equipbyid(45578);
                    return;

                }
                if (!IsMaxExalted(69) && HasItem(45579))
                {
                    Slog("Need More Reputation with Darnassus, Equiping correct Tabard.");
                    Equipbyid(45579);
                    return;

                }
                if (!IsMaxExalted(1134) && HasItem(64882))
                {
                    Slog("Need More Reputation with Gilneas, Equiping correct Tabard.");
                    Equipbyid(64882);
                    return;
                }
                if (!IsMaxExalted(930) && HasItem(45580))
                {
                    Slog("Need More Reputation with Exodar, Equiping correct Tabard.");
                    Equipbyid(45580);
                    return;
                }
                if (!HasItem(45574) && !HasItem(83079) && !HasItem(45577) && !HasItem(45578) && !HasItem(45579) && !HasItem(64882) && !HasItem(45580))
                {
                    Slog("I dont have ANY tabards! disable the plugin or ignore this message till you buy some tabards");
                    return;
                }

            }
            //now we do our orginal check. 
            if (!IsMaxExalted(72) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 45574)
            {
                //ITs equiped, we dont care if we have it, so the HasItem() check is not needed.
                return;
            }
            if (!IsMaxExalted(72) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 45574 && HasItem(45574))
            {
                Slog("Need More Reputation with Stormwind, Equiping correct Tabard.");
                Equipbyid(45574);
                return;

            }
            if (!IsMaxExalted(1353) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 83079)
            {
                return;
            }
            if (!IsMaxExalted(1353) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 83079 && HasItem(83079))
            {

                Slog("Need More Reputation with Tushui Pandaren, Equiping correct Tabard.");
                Equipbyid(83079);
                return;

            }
            if (!IsMaxExalted(47) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 45577)
            {
                return;
            }
            if (!IsMaxExalted(47) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 45577 && HasItem(45577))
            {
                Slog("Need More Reputation with Ironforge, Equiping correct Tabard.");
                Equipbyid(45577);
                return;

            }
            if (!IsMaxExalted(54) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 45578)
            {
                return;
            }
            if (!IsMaxExalted(54) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 45578 && HasItem(45578))
            {
                Slog("Need More Reputation with Gnomeregan, Equiping correct Tabard.");
                Equipbyid(45578);
                return;

            }
            if (!IsMaxExalted(69) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 45579)
            {
                return;
            }
            if (!IsMaxExalted(69) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 45579 && HasItem(45579))
            {
                Slog("Need More Reputation with Darnassus, Equiping correct Tabard.");
                Equipbyid(45579);
                return;

            }
            if (!IsMaxExalted(1134) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 64882)
            {
                return;
            }
            if (!IsMaxExalted(1134) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 64882 && HasItem(64882))
            {
                Slog("Need More Reputation with Gilneas, Equiping correct Tabard.");
                Equipbyid(64882);
                return;

            }
            if (!IsMaxExalted(930) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 45580)
            {
                return;
            }
            if (!IsMaxExalted(930) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 45580 && HasItem(45580))
            {
                Slog("Need More Reputation with Exodar, Equiping correct Tabard.");
                Equipbyid(45580);
                return;
            }
            
        }
        public void Horde()
        {
            if (IsMaxExalted(81) && IsMaxExalted(530) && IsMaxExalted(76) &&
               IsMaxExalted(1133) && IsMaxExalted(1352) && IsMaxExalted(68) &&
               IsMaxExalted(911))
            {
                foreach (PluginContainer Plugin in Styx.Plugins.PluginManager.Plugins)
                {
                    if (Plugin.Name == "MrTabardSwitcher")
                    {
                        Slog("Congradulations! Your now Exalted with all Major Factions! Disabling MrTabardSwitcher");
                        Plugin.Enabled = false;
                    }
                }
            }
            //Checking incase tabards are null.
            if (StyxWoW.Me.Inventory.Equipped.Tabard.Entry == null)
            {
                Slog("No Currently Equiped Tabard!");
                //got an issue, theres not a tabard already equiped. finding one to equip.
                //Checking for SW Rep, then if we have the item to equip.
                //Thunder Bluff / Tabard
                if (!IsMaxExalted(81) && HasItem(45584))
                {

                    Slog("Need More Reputation with Thunder Bluff, Equiping correct Tabard.");
                    Equipbyid(45584);
                    return;

                }
                //Darkspear Trolls / Tabard
                if (!IsMaxExalted(530) && HasItem(45582))
                {

                    Slog("Need More Reputation with Darkspear Trolls, Equiping correct Tabard.");
                    Equipbyid(45582);
                    return;

                }
                //Orgrimmar / Tabard
                if (!IsMaxExalted(76) && HasItem(45581))
                {
                    Slog("Need More Reputation with Orgrimmar, Equiping correct Tabard.");
                    Equipbyid(45581);
                    return;

                }
                //Bilgewater Cartel - Goblin / Tabard
                if (!IsMaxExalted(1133) && HasItem(64884))
                {
                    Slog("Need More Reputation with Bilgewater Cartel Goblins, Equiping correct Tabard.");
                    Equipbyid(64884);
                    return;

                }
                //Huojin Panda / Tabard
                if (!IsMaxExalted(1352) && HasItem(83080))
                {
                    Slog("Need More Reputation with Huojin Panda's, Equiping correct Tabard.");
                    Equipbyid(83080);
                    return;

                }
                //Undercity / Tabard
                if (!IsMaxExalted(68) && HasItem(45583))
                {
                    Slog("Need More Reputation with Undercity, Equiping correct Tabard.");
                    Equipbyid(45583);
                    return;
                }
                //Silvermmon / tabard
                if (!IsMaxExalted(911) && HasItem(45585))
                {
                    Slog("Need More Reputation with Silvermmon, Equiping correct Tabard.");
                    Equipbyid(45585);
                    return;
                }
                if (!HasItem(45584) && !HasItem(45582) && !HasItem(45581) && !HasItem(64884) && !HasItem(83080) && !HasItem(45583) && !HasItem(45585))
                {
                    Slog("I dont have ANY tabards! disable the plugin or ignore this message till you buy some tabards");
                    return;
                }
            }
            //now we do our orginal check. 
            if (!IsMaxExalted(81) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 45584)
            {
                //ITs equiped, we dont care if we have it, so the HasItem() check is not needed.
                return;
            }
            if (!IsMaxExalted(81) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 45584 && HasItem(45584))
            {
                Slog("Need More Reputation with Thunder Bluff, Equiping correct Tabard.");
                Equipbyid(45584);
                return;

            }
            if (!IsMaxExalted(530) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 45582)
            {
                return;
            }
            if (!IsMaxExalted(530) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 45582 && HasItem(45582))
            {

                Slog("Need More Reputation with Darkspear Trolls, Equiping correct Tabard.");
                Equipbyid(45582);
                return;

            }
            if (!IsMaxExalted(76) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 45581)
            {
                return;
            }
            if (!IsMaxExalted(76) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 45581 && HasItem(45581))
            {
                Slog("Need More Reputation with Orgrimmar, Equiping correct Tabard.");
                Equipbyid(45581);
                return;

            }
            if (!IsMaxExalted(1133) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 64884)
            {
                return;
            }
            if (!IsMaxExalted(1133) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 64884 && HasItem(64884))
            {
                Slog("Need More Reputation with Bilgewater Cartel Goblins, Equiping correct Tabard.");
                Equipbyid(64884);
                return;

            }
            if (!IsMaxExalted(1352) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 83080)
            {
                return;
            }
            if (!IsMaxExalted(1352) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 83080 && HasItem(83080))
            {
                Slog("Need More Reputation with Huojin Panda's, Equiping correct Tabard.");
                Equipbyid(83080);
                return;

            }
            if (!IsMaxExalted(68) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 45583)
            {
                return;
            }
            if (!IsMaxExalted(68) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 45583 && HasItem(45583))
            {
                Slog("Need More Reputation with Undercity, Equiping correct Tabard.");
                Equipbyid(45583);
                return;

            }
            if (!IsMaxExalted(911) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry == 45585)
            {
                return;
            }
            if (!IsMaxExalted(911) && StyxWoW.Me.Inventory.Equipped.Tabard.Entry != 45585 && HasItem(45585))
            {
                Slog("Need More Reputation with Silvermmon, Equiping correct Tabard.");
                Equipbyid(45585);
                return;
            }
           
        }
         public static void Equipbyid(int id)
        {
            foreach (WoWItem item in Me.BagItems)
            {
                if(item.Entry == id)
                {
                    EquipItem(item);
                    return;
                }
            }
        }
         public static bool HasItem(int id)
         {
             foreach (WoWItem item in Me.BagItems)
             {
                 if (item.Entry == id)
                 {
                     return true;
                 }
             }
             return false;
         }
         private static void EquipItem(int bagIndex, int bagSlot, int targetSlot)
         {
             Lua.DoString(
                 "ClearCursor(); PickupContainerItem({0}, {1}); EquipCursorItem({2}); if StaticPopup1Button1 and StaticPopup1Button1:IsVisible() then StaticPopup1Button1:Click(); end;",
                 bagIndex + 1, bagSlot + 1, targetSlot);
              Thread.Sleep(2000);
         }

         private static void EquipItemIntoSlot(WoWItem item, InventorySlot slot)
         {
             EquipItem(item.BagIndex, item.BagSlot, (int)slot);
         }

         private static void EquipItem(WoWItem item)
         {
             EquipItem(item.BagIndex, item.BagSlot, (int)item.ItemInfo.EquipSlot);
         }
        


        public bool IsTabardEquiped(int ItemID)
        {
            if(StyxWoW.Me.Inventory.Equipped.Tabard.Entry == null)
            {
                //Nothing equiped
                return true;
            }
            if (StyxWoW.Me.Inventory.Equipped.Tabard.Entry != ItemID)
            {
                //Something Equiped, but not what we want.
                return true;
            }
            if (StyxWoW.Me.Inventory.Equipped.Tabard.Entry == ItemID)
            {
                //Equiped and is What we want.
                return false;
            }
            //Equiped and is What we want. / Dont do anything
            return false;
      
        }

        public bool IsMaxExalted(uint id)
        {
            if (Me.GetReputationWith(id) == 42999)
            {
                //i am 100% exalted.
                return true;
            }
            if (Me.GetReputationWith(id) < 42999)
            {
                //i am NOT 100% exalted.
                return false;
            }

            return false;
        }


    }
}

